summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorBruno Haible <bruno@clisp.org>2004-01-06 10:22:43 +0000
committerBruno Haible <bruno@clisp.org>2009-06-23 12:11:33 +0200
commit4e4dc77d259fe03361ae42b99c801d0485bca72f (patch)
tree824fe6e02fb64f2fa21e66cbc4e332ff2b349ef8
parent2ed89e80c6fccbc61bb6e045f98b84555ce1894b (diff)
downloadexternal_gettext-4e4dc77d259fe03361ae42b99c801d0485bca72f.zip
external_gettext-4e4dc77d259fe03361ae42b99c801d0485bca72f.tar.gz
external_gettext-4e4dc77d259fe03361ae42b99c801d0485bca72f.tar.bz2
Tests for C# format string recognition.
-rwxr-xr-xgettext-tools/tests/format-csharp-189
-rwxr-xr-xgettext-tools/tests/format-csharp-279
2 files changed, 168 insertions, 0 deletions
diff --git a/gettext-tools/tests/format-csharp-1 b/gettext-tools/tests/format-csharp-1
new file mode 100755
index 0000000..c6ed606
--- /dev/null
+++ b/gettext-tools/tests/format-csharp-1
@@ -0,0 +1,89 @@
+#! /bin/sh
+
+# Test recognition of C# format strings.
+
+tmpfiles=""
+trap 'rm -fr $tmpfiles' 1 2 3 15
+
+tmpfiles="$tmpfiles f-cs-1.data"
+cat <<\EOF > f-cs-1.data
+# Valid: one argument
+"abc{0}def"
+# Valid: ten arguments
+"abc{9}def"
+# Valid: two-digit argument numbers
+"abc{00}def"
+# Valid: huge argument numbers
+"abc{500000000}def"
+# Invalid: unterminated
+"abc{"
+# Invalid: unterminated
+"abc{0"
+# Invalid: missing number
+"abc{}def"
+# Invalid: non-digit
+"abc{number}def"
+# Invalid: non-digit
+"abc{-0}def"
+# Valid: two arguments
+"abc{1}def{0}"
+# Valid: multiple uses of same argument
+"abc{1}def{0}ghi{1}"
+# Invalid: invalid width
+"abc{0,}def"
+# Invalid: invalid width
+"abc{0,-}def"
+# Valid: valid width
+"abc{1,-7}def"
+# Valid: format specifiers
+"abc{1:Gx N}def"
+# Valid: width and format specifiers
+"abc{1,3:Gx N}def"
+# Invalid: missing opening brace
+"abc1}def{0}"
+# Invalid: quoted brace
+"abc1'}'def{0}"
+# Valid: doubled brace
+"abc1}}def{0}"
+# Invalid: doubled brace doesn't start a directive
+"abc{{0}def"
+EOF
+
+: ${XGETTEXT=xgettext}
+n=0
+while read comment; do
+ read string
+ n=`expr $n + 1`
+ tmpfiles="$tmpfiles f-cs-1-$n.in f-cs-1-$n.po"
+ cat <<EOF > f-cs-1-$n.in
+GetString(${string});
+EOF
+ ${XGETTEXT} -L C# -o f-cs-1-$n.po f-cs-1-$n.in || exit 1
+ test -f f-cs-1-$n.po || exit 1
+ fail=
+ if echo "$comment" | grep 'Valid:' > /dev/null; then
+ if grep csharp-format f-cs-1-$n.po > /dev/null; then
+ :
+ else
+ fail=yes
+ fi
+ else
+ if grep csharp-format f-cs-1-$n.po > /dev/null; then
+ fail=yes
+ else
+ :
+ fi
+ fi
+ if test -n "$fail"; then
+ echo "Format string recognition error:" 1>&2
+ cat f-cs-1-$n.in 1>&2
+ echo "Got:" 1>&2
+ cat f-cs-1-$n.po 1>&2
+ exit 1
+ fi
+ rm -f f-cs-1-$n.in f-cs-1-$n.po
+done < f-cs-1.data
+
+rm -fr $tmpfiles
+
+exit 0
diff --git a/gettext-tools/tests/format-csharp-2 b/gettext-tools/tests/format-csharp-2
new file mode 100755
index 0000000..9180bc1
--- /dev/null
+++ b/gettext-tools/tests/format-csharp-2
@@ -0,0 +1,79 @@
+#! /bin/sh
+
+# Test checking of Java format strings.
+
+tmpfiles=""
+trap 'rm -fr $tmpfiles' 1 2 3 15
+
+tmpfiles="$tmpfiles f-cs-2.data"
+cat <<\EOF > f-cs-2.data
+# Invalid: invalid msgstr
+msgid "abc{0}def"
+msgstr "abc{"
+# Valid: same arguments
+msgid "abc{1}def"
+msgstr "xyz{1}"
+# Valid: same arguments, differently written
+msgid "abc{1}def"
+msgstr "xyz{01}"
+# Valid: permutation
+msgid "abc{2}{0}{1}def"
+msgstr "xyz{1}{0}{2}"
+# Invalid: too few arguments
+msgid "abc{1}def{0}"
+msgstr "xyz{0}"
+# Invalid: too many arguments
+msgid "abc{0}def"
+msgstr "xyz{0}uvw{1}"
+# Valid: missing non-final argument
+msgid "abc{1}def{0}"
+msgstr "xyz{1}"
+# Valid: added non-final argument
+msgid "abc{1}def"
+msgstr "xyz{0}{1}"
+# Invalid: different number of arguments
+msgid "abc{500000000}def"
+msgstr "xyz{500000001}"
+# Valid: type compatibility
+msgid "abc{1:X}"
+msgstr "xyz{1:g}"
+EOF
+
+: ${MSGFMT=msgfmt}
+n=0
+while read comment; do
+ read msgid_line
+ read msgstr_line
+ n=`expr $n + 1`
+ tmpfiles="$tmpfiles f-cs-2-$n.po f-cs-2-$n.mo"
+ cat <<EOF > f-cs-2-$n.po
+#, csharp-format
+${msgid_line}
+${msgstr_line}
+EOF
+ fail=
+ if echo "$comment" | grep 'Valid:' > /dev/null; then
+ if ${MSGFMT} --check-format -o f-cs-2-$n.mo f-cs-2-$n.po; then
+ :
+ else
+ fail=yes
+ fi
+ else
+ ${MSGFMT} --check-format -o f-cs-2-$n.mo f-cs-2-$n.po 2> /dev/null
+ if test $? = 1; then
+ :
+ else
+ fail=yes
+ fi
+ fi
+ if test -n "$fail"; then
+ echo "Format string checking error:" 1>&2
+ cat f-cs-2-$n.po 1>&2
+ exit 1
+ fi
+ rm -f f-cs-2-$n.po f-cs-2-$n.mo
+done < f-cs-2.data
+
+rm -fr $tmpfiles
+
+exit 0